// Copyright (c) 2002 Cathay Networks, Inc.  
// see LICENSE file for details of VOCAL license

#ifndef config_h
#define config_h


/******************* configuration setting stuff ********************/

// data struct for configuration data 
typedef struct  
{
      int httpStatsPort;
      int peerListenPort;
      int printStatsTime;
      int probePort;
      int reqPort;
      int respPort;
      int sinkPort;
      int stickyTableSize;
      int stickyExpireTime; // in seconds 
      int genReqIp;
      int genReqPort;
      int genRespIp;
      int genRespPort;
      int genRespDstIp;
      int genRespDstPort;
      int cps;
      int runTime;
      bool checkMaxHop;
      bool checkProxyRequire;
      bool loopDetect;
      bool verbose;
      bool testRandomRib;
      bool supportNat;
      char proxyName[512];
      char useStickyType[64];
} Setting;

extern Setting setting;


/// take a string and convert it to a int and overwrite the value of v
void setValue( int* v, char* s );

void parseCommandLine(int argc, char* argv[] );

// Local Variables:
// mode:c++
// c-file-style:"bsd"
// c-file-offsets:((case-label . +))
// c-basic-offset:4
// indent-tabs-mode:nil
// End:
#endif
