// Copyright (c) 2002 Cathay Networks, Inc.  
// see LICENSE file for details of VOCAL license

#ifndef rib_h
#define rib_h

#include "network.h"

/// sticky cache
typedef struct 
{
      short int proxy; // index into DstProxy array to (-1 for empty entries )
      Int64 time; // time a request was last seen from this item 
      unsigned int hash; 
} Rib;

// This datastructire is an array that is allocated on start up and 
// is index by the sticky hash and points to an entry in in the 
// DstProxy array that indicates which proxy to send the call too. 
// rib stands for routing information base 
extern Rib* rib;
extern int ribSize;

int getRibIndex( unsigned int hash );
void expireRib( int index );
int getRibProxy( unsigned int hash );
int findPeer( Socket fd );
int findProxy( unsigned int ip, int port );
void addProxy( int ip, int port, int priority, int weight, bool probe );

// Local Variables:
// mode:c++
// c-file-style:"bsd"
// c-file-offsets:((case-label . +))
// c-basic-offset:4
// indent-tabs-mode:nil
// End:
#endif
