// Copyright (c) 2002 Cathay Networks, Inc.  
// see LICENSE file for details of VOCAL license

/************************ String Parsing Stuff **********************/

#include <cassert>
#include <string.h>
#if 0
#include <netdb.h>
#endif

#include "string.h"


/// find a sip header in a buffer 
int 
findHeader(char *header,char* buf, int len)
{
   char *loc = strstr(buf,header);
    
   if ( loc == NULL ) 
   {
      return len;
   }
    
   int d = loc-buf;
    
   assert( d >= 0 );
   assert( d < len );
    
   return d;
}


/// find the next end of line in a buffer 
int 
findEOL(char* buf, int len)
{
   return findHeader("\r\n",buf,len);
}


/// find the next end of line in a buffer 
int 
findColon(char* buf, int len)
{
   return findHeader(":",buf,len);
}


/// find a SIP tag in a buffer 
int 
findBranch(char* buf, int len)
{
   return findHeader("branch=",buf,len);
}


/// compute a good hash of a string 
unsigned int 
stringHash( char* s, int len)
{
#if 0 
   // TODO - compute md5 hash of the string 
#else
   // this is a very lame hash but makes for easy testing 
   unsigned int sum=0;
   //int len = strlen( s );
    
   for( int i=0; i<len; i++ )
   {
      sum += static_cast<unsigned char>(s[i]);
   }
    
   return sum;
#endif
}

#if 0
// string extraction utility
string
extractString(const string& start,
              const string& end,
              const string& from)
{
   string::size_type spos = from.find(start);
   string::size_type epos = from.find(end, spos+start.size());
   //assert(spos != string::npos && epos != string::npos);
   return from.substr(spos+start.size(), epos-spos-start.size());
}
#endif


// c-basic-offset:4
// Local Variables:
// mode:c++
// c-file-style:"ellemtel"
// c-file-offsets:((case-label . +))
// indent-tabs-mode:nil
// End:
