// Copyright (c) 2002 Cathay Networks, Inc.  
// see LICENSE file for details of VOCAL license

#ifndef time_h
#define time_h

#include "network.h"

const Int64 oneSecond = 1000000;

Int64 getTimeSlow();
Int64 getTimeRelative();
Int64 getTime(bool update=false);
Int64 getNtpTime();


/// get low 32 bits of 64 bits
inline Int32 
low32( Int64 i )
{
   return static_cast<Int32>(i);
}


/// get high 32 bits of 64 bits 
inline Int32 
high32( Int64 i )
{
   Int64 r=i;
   r = r>>32;
   return static_cast<Int32>(r);
}


/// for a 64 bit from two 32 bit things 
inline Int64 
form64( Int32 low, Int32 high )
{
   Int64 r;
   r = high;
   r = r<<32;
   r = r|low;
   return r;
}

// Local Variables:
// mode:c++
// c-file-style:"bsd"
// c-file-offsets:((case-label . +))
// c-basic-offset:4
// indent-tabs-mode:nil
// End:
#endif
