// Copyright (c) 2002 Cathay Networks, Inc.  
// see LICENSE file for details of VOCAL license

#ifndef udp_h
#define udp_h

/*************************** UDP networking stuff  *******************/

#include "network.h"

const int udpMaxMessageLength=16*1024;

/// Open a UDP socket to send to a particular destination
Socket
openSendPort( int ip, unsigned short port );

/// Open a UDP socket to receive on the given port 
Socket
openRecvPort( unsigned short port );

/// recive a UDP message 
bool 
getMessage( Socket fd, char* buf, int* len,
	    unsigned int* srcIp, unsigned short* srcPort );

/// send a UDP message 
bool 
sendMessage( Socket fd, char* msgVec[], int lenVec[], int numVec, 
	     unsigned int dstIp=0, unsigned short dstPort=0 );

// Local Variables:
// mode:c++
// c-file-style:"bsd"
// c-file-offsets:((case-label . +))
// c-basic-offset:4
// indent-tabs-mode:nil
// End:
#endif
